
#include <stdio.h>
#include <stdlib.h>

#include "base.h"
#include "grises.h"
#include "inclfont.h"
#include "inclina.h"
#include "inclina0.h"
#include "line.h"
#include "lista.h"
#include "imag.h"

//************************ raya **********************

tline nuevaRaya (int u0, int v0, int u1, int v1)
{
  tline line;
  line = (tline) malloc (sizeof(struct teline));
  line -> u0 = u0 ;
  line -> u1 = u1 ;
  line -> v0 = v0 ;
  line -> v1 = v1 ;
  line -> tp = ' ';
  return line ;
}

tline copiaRaya (tline line)
{
  return nuevaRaya (line->u0, line->v0, line->u1, line->v1);
}

void anyadeRaya1 (lista lineas, int u0, int v0, int u1, int v1)
{
  tline line;
  line = nuevaRaya (u0, v0, u1, v1);
  aniadeafinlista (lineas, (tline) line);
}

void anyadeRaya (lista lineas, tline line)
{
  aniadeafinlista (lineas, (tline) line);
}

void leeRaya (tline *line)
{
  int u0, v0, u1, v1;
  scanf ("%d %d  %d %d", &u0, &v0, &u1, &v1);
  *line = nuevaRaya (u0, v0, u1, v1);
}

void leeRayas (lista *nlineas)
{
  tline line;
  lista lineas;
  lineas = listaNueva ();
  leeRaya (&line);
  while (line->u0 >= 0) {
    anyadeRaya (lineas, line);
    leeRaya (&line);
    }
  *nlineas = lineas;
}

void imprimeRaya (tline line)
{
  printf ("%4d %4d  %4d %4d  %4d %4d %c\n",
	   line->u0, line->v0, line->u1, line->v1,
           line->u1-line->u0 + 1,  line->v1-line->v0 + 1, line->tp);
}

void imprimeRayas (lista lineas)
{
  int i=0;
  tnodol nodol;
  printf ("  n   u0   v0    u1   v1    tu   tv \n");
  printf (" --- ---- ----  ---- ----  ---- ----\n");
  for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
    printf ("%4d ", i);
    imprimeRaya ( (tline) nodol->aitem );
    i++ ;
    }
}

void imprimeRayasCab (lista lineas, char *text)
{
  printf ("%s\n", text);
  imprimeRayas (lineas);
}

int sumaAnchoRayas (lista lineas)
{
  int sum=0;
  tnodol nodol;
  tline linea;
  for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
    linea = (tline) nodol->aitem ;
    sum += linea->v1 - linea->v0 + 1 ;
    }
  return sum ;
}

//************************ xxxxx **********************

int areaDeSegmento (tline s)
{
  return (s->u1 - s->u0 + 1)* (s->v1 - s->v0 + 1);
}

int areaDeSegmentos (lista segs)
{
  int s=0;
  tnodol nodol;
  for (nodol = segs->primero; nodol != 0L;nodol = nodol->siguiente) {
    s += areaDeSegmento ( (tline) nodol->aitem );
    }
  return s ;
}

void anyadeSiBien (lista lsg, int u0, int v0, int u1, int v1)
{
  if ( (u1 > u0) &&
       (v1 > v0)    )
    anyadeRaya1 (lsg, u0, v0, u1, v1);
}

void segmentosHastaSegDerechaoAbajo (lista *nsegmentos, tline stext, tline slim)
{
  lista segmts;
  segmts = listaNueva ();
  anyadeSiBien (segmts, stext->u0, stext->v0, slim->u0-1, stext->v1);
  anyadeSiBien (segmts, max(stext->u0, slim->u0),
                        stext->v0,
                        min(stext->u1, slim->u1),
		        slim->v0-1);
  anyadeSiBien (segmts, slim->u1+1, stext->v0, stext->u1, stext->v1);
  *nsegmentos = segmts;
}

void segmentosHastaSegIzquierdaoArriba (lista *nsegmentos, tline stext, tline slim)
{
  lista segmts;
  segmts = listaNueva ();
  anyadeSiBien (segmts, stext->u0, stext->v0, slim->u0-1, stext->v1);
  anyadeSiBien (segmts, max(stext->u0, slim->u0),
                        slim->v1+1,
                        min(stext->u1, slim->u1),
		        stext->v1);
  anyadeSiBien (segmts, slim->u1+1, stext->v0, stext->u1, stext->v1);
  *nsegmentos = segmts;
}

Boolean disjuntosSegmentos (tline s1, tline s2)
{
  return (s1->u1 < s2->u0) || (s2->u1 < s1->u0) ||
         (s1->v1 < s2->v0) || (s2->v1 < s1->v0)    ;
}

void segmentosHastaListaSegDerechaoAbajo (lista *nsegsDer, tline segDer, lista sslim)
{
  tnodol nodoltx, nodoltxsig, nodollm;
  lista segsDer, segs1;
  segsDer = listaNueva ();
  anyadeRaya (segsDer, segDer);
  for (nodollm = sslim->primero; nodollm != 0L;nodollm = nodollm->siguiente) {
    for (nodoltx = segsDer->primero; nodoltx != 0L;nodoltx = nodoltxsig) {
      nodoltxsig = nodoltx->siguiente ;
      if ( ! disjuntosSegmentos ((tline) nodoltx->aitem, (tline) nodollm->aitem ) ) {
        segmentosHastaSegDerechaoAbajo (&segs1, (tline) nodoltx->aitem,
		                                (tline) nodollm->aitem );
        substituyePorListaNodo  (segsDer, segs1, nodoltx);
	free (nodoltx->aitem);
	free (nodoltx);
        }
      }
    }
  *nsegsDer = segsDer;
}

void segmentosHastaListaSegIzquierdaoArriba (lista *nsegsIzq, tline segIzq, lista sslim)
{
  tnodol nodoltx, nodoltxsig, nodollm;
  lista segsIzq, segs1;
  segsIzq = listaNueva ();
  anyadeRaya (segsIzq, segIzq);
  for (nodollm = sslim->primero; nodollm != 0L;nodollm = nodollm->siguiente) {
    for (nodoltx = segsIzq->primero; nodoltx != 0L;nodoltx = nodoltxsig) {
      nodoltxsig = nodoltx->siguiente ;
      if ( ! disjuntosSegmentos ((tline) nodoltx->aitem, (tline) nodollm->aitem ) ) {
        segmentosHastaSegIzquierdaoArriba (&segs1, (tline) nodoltx->aitem,
		                                (tline) nodollm->aitem );
        substituyePorListaNodo  (segsIzq, segs1, nodoltx);
	free (nodoltx->aitem);
	free (nodoltx);
        }
      }
    }
  *nsegsIzq = segsIzq;
}

int areaMenorSegsIzqDer (tline lin, lista segsLim, int tamv)
{
  tline sd, si;
  lista segsDer, segsIzq ;
  int areaDer, areaIzq ;
  sd = nuevaRaya (lin->u0, lin->v1+1, lin->u1, tamv-1);
  segmentosHastaListaSegDerechaoAbajo (&segsDer, sd, segsLim);
  areaDer = areaDeSegmentos (segsDer);
  liberaItemsNodosYlista (segsDer);
  si = nuevaRaya (lin->u0, 0, lin->u1, lin->v0 - 1);
  segmentosHastaListaSegIzquierdaoArriba (&segsIzq, si, segsLim);
  areaIzq = areaDeSegmentos (segsIzq);
  liberaItemsNodosYlista (segsIzq);
  return  min(areaIzq, areaDer) ;
}

void tomaLineasLim (lista *nlineasLim, lista blin, int tamv)
{
  // atencion, se cambia blin
  lista lineasLim;
  tnodol nodolmax;
  int n;
  lineasLim = listaNueva ();
  for (n=0; n<5; n++) {
    tnodol nodol;
    int arminmax, armin;
    arminmax = 0;
    for (nodol = blin->primero; nodol != (tnodol) 0L; nodol = nodol->siguiente) {
      armin = areaMenorSegsIzqDer ((tline) nodol->aitem, lineasLim, tamv);
      if (armin > arminmax) {
	arminmax = armin;
	nodolmax = nodol;
	}
      }
    anyadeRaya (lineasLim, (tline) nodolmax->aitem);
    eliminaNdelista (blin, nodolmax);
    }
  *nlineasLim = lineasLim;
}

void pruebaLine ()
{
  // tline s1, s2;
  // leeRaya (&s1); imprimeRaya (s1);
  lista segsLim, blin;
  leeRayas (&blin);
  imprimeRayas (blin);
  tomaLineasLim (&segsLim, blin, 40);
  imprimeRayas (segsLim);
  exit (0);
}

void pruebaLine2 ()
{
  tline s1;
  // tline s2;
  lista segsLim;
  // lista segsDer;
  leeRaya (&s1); imprimeRaya (s1);
  leeRayas (&segsLim);
  imprimeRayas (segsLim);
  printf ("area menor: %4d\n", areaMenorSegsIzqDer (s1, segsLim, 40) );
  exit (0);
}

//************************ xxxxx **********************

void unionSegs (lista lineasAgr,
		lista lineas,   tnodol cg, tnodol fg )
{
  int sigder, usigder, sigiz; // siguiente derechea, ultimo id, siguiente izq
  tnodol nodol;
  tline line;
  int minr1 = -1 ;
  int maxm1 = 1000000 ;
  int seAvanza;
  usigder = minr1 ;
  while (TRUE) {
    sigiz = maxm1 ;
    // desde  cg  a  fg  inclusive
    for  (nodol = cg ;  ; nodol = nodol->siguiente) {
      line = (tline) nodol->aitem ;
      if ((line->u0 < sigiz) && (line->u0 > usigder)) {
        sigiz  = line->u0 ;
	sigder = line->u1 ;
        }
      if (nodol == fg) break ;
      }
    if (sigiz == maxm1) break ;
    seAvanza = TRUE ;
    while (seAvanza) {
      seAvanza = FALSE ;
      // desde  cg  a  fg  inclusive
      for  (nodol = cg ;  ; nodol = nodol->siguiente) {
        line = (tline) nodol->aitem ;
	if ((line->u0 <= (sigder + 1)) &&
	    (line->u0 >= sigiz) &&
	    (line->u1 > sigder)) {
	  sigder = line->u1 ;
	  seAvanza = TRUE ;
	  }
        if (nodol == fg) break ;
        }
      }
    // printf ("    %4d %4d\n", sigiz, sigder);
    anyadeRaya1 (lineasAgr,
		  sigiz,  ((tline)cg->aitem)->v0,
		  sigder, ((tline)fg->aitem)->v1) ;
    usigder = sigder ;
    }
}

void agrupaRayas (lista *nlineasAgr, lista lineas)
{
  lista lineasAgr;
  tnodol cg, fg;    // comienzo grupo y fin grupo
  tline line;
  tnodol nodol;
  lineasAgr = listaNueva ();
  if ( ! listaVacia (lineas) ) {
    cg = lineas->primero ;
    for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
      line = (tline) nodol->aitem;
      if ((nodol->siguiente != 0L) &&
          ( ((tline)nodol->siguiente->aitem)->v0 - line->v1 >1) ){
        fg = nodol;
        // printf ("%4d %4d  %4d %4d\n", cg, fg, lineas[cg]->v0, lineas[fg]->v1);
        unionSegs (lineasAgr, lineas, cg, fg);
        cg = nodol->siguiente ;
        }
      }
    fg = lineas->ultimo;
    // printf ("%4d %4d  %4d %4d\n", cg, fg, lineas[cg]->v0, lineas[fg]->v1);
    unionSegs (lineasAgr, lineas, cg, fg);
    }
  *nlineasAgr = lineasAgr;
}

void anyadeLineaAgrupo (lista lineasAgr, tline line, int lmin)
{
  tnodol nodol;
  Boolean anyad ;
  anyad = FALSE ;
  if (! listaVacia(lineasAgr) )
    for (nodol = lineasAgr->primero; nodol != 0L; nodol = nodol->siguiente) {
      tline lineg;
      lineg = (tline) nodol->aitem;
      if (line->v0 == (lineg->v1 + 1)) {
        int u0n, u1n;
        u0n = max (line->u0, lineg->u0);
        u1n = min (line->u1, lineg->u1);
        if ((u1n - u0n + 1) >= lmin) {
          int area, arean;
          area  = (lineg->u1 - lineg->u0 + 1) * 
                  (lineg->v1 - lineg->v0 + 1) ;
          arean = (u1n       - u0n       + 1) * 
                  (lineg->v1 - lineg->v0 + 2) ;
          if (arean > area) {
	    lineg->u0 = u0n;
	    lineg->u1 = u1n;
	    lineg->v1 ++;
            anyad = TRUE ;
	    }
          }
        }
      }
  if (!anyad) 
     anyadeRaya (lineasAgr, copiaRaya(line));
}

void agrupaRayasB (lista *nlineasAgr, lista lineas, int lmin)
{
  lista lineasAgr;
  tline line;
  tnodol nodol;
  lineasAgr = listaNueva ();
  if ( ! listaVacia (lineas) ) {
    for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
      line = (tline) nodol->aitem;
      anyadeLineaAgrupo (lineasAgr, line, lmin) ;
      }
    }
  *nlineasAgr = lineasAgr;
}

//*********************** raya y ventana **********************

void sigueRayasHor1y (lista lineas, tvent vent, int umbral, int y)
{
  char ** pix;
  int x;
  int po, uo; // primer oscuro, ultimo ...
  int px, pxa; // pixel, pixel anterior
  // int lmin = 45;
  int lmin = 60;
  pix = vent->pix ;
    pxa = 255 ; // valor mayor de nivel de gris
    for (x=0; x<vent->tx; x++) {
      px = pix[y][x] & 0xFF ;
      if ((px < umbral) && (pxa >= umbral))
        po = x;
      if ((px >= umbral) && (pxa < umbral)) {
        uo = x - 1 ;
        if ((uo - po + 1) >= lmin) {
          anyadeRaya1 (lineas, po, y, uo, y) ;
          // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
        }
      }
      pxa = px;
      }
    if ((pxa < umbral)) {
      uo = vent->tx ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, y, uo, y) ;
        // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
        }
      }
}

void sigueRayasHorBlan1y (lista lineas, tvent vent, int umbral, int y, int lmin)
{
  char ** pix;
  int x;
  int po, uo; // primer oscuro, ultimo ...
  int px, pxa; // pixel, pixel anterior
  pix = vent->pix ;
    pxa = 0 ; /* valor menor de nivel de gris */
    for (x=0; x<vent->tx; x++) {
      px = pix[y][x] & 0xFF ;
      if ((px >= umbral) && (pxa < umbral))
        po = x;
      if ((px < umbral) && (pxa >= umbral)) {
        uo = x - 1 ;
        if ((uo - po + 1) >= lmin) {
          anyadeRaya1 (lineas, po, y, uo, y) ;
          // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
        }
      }
      pxa = px;
      }
    if ((pxa >= umbral)) {
      uo = vent->tx ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, y, uo, y) ;
        // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
        }
      }
}

void sigueRayasVer1x (lista lineas, tvent vent, int umbral, int x, int inclv)
{
  char ** pix;
  int y;
  int xc;
  int ty, tyd2;
  int po, uo; // primer oscuro, ultimo ...
  int px, pxa; // pixel, pixel anterior
  int lmin = 75;
  pix = vent->pix ;
  ty = vent->ty ;
  tyd2 = ty / 2 ;
  pxa = 255 ; // valor mayor de nivel de gris
  for (y=0; y<ty; y++) {
    // xc = x + (y * inclv + tyd2)/ty ;
    xc = x + (y * inclv )/INCLF_DIV ;
    px = pix[y][xc] & 0xFF ;
    if ((px < umbral) && (pxa >= umbral))
      po = y;
    if ((px >= umbral) && (pxa < umbral)) {
      uo = y - 1 ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, x, uo, x) ;
        // printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
        }
      }
    pxa = px;
    }
  if ((pxa < umbral)) {
    uo = vent->ty ;
    if ((uo - po + 1) >= lmin) {
      anyadeRaya1 (lineas, po, x, uo, x) ;
      // printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
      }
    }
}

void sigueRayasVerBlan1x (lista lineas, tvent vent, int umbral, int x, int lmin, int inclv)
{
  char ** pix;
  int y;
  int xc;
  int ty, tyd2;
  int po, uo; // primer oscuro, ultimo ...
  int px, pxa; // pixel, pixel anterior
  pix = vent->pix ;
  ty = vent->ty ;
  tyd2 = ty / 2 ;
  pxa = 0 ; // valor menor de nivel de gris
  for (y=0; y<ty; y++) {
    // xc = x + (y * inclv + tyd2)/ty ;
    xc = x + (y * inclv )/INCLF_DIV ;
    px = pix[y][xc] & 0xFF ;
    if ((px >= umbral) && (pxa < umbral))
      po = y;
    if ((px < umbral) && (pxa >= umbral)) {
      uo = y - 1 ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, x, uo, x) ;
        // printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
        }
      }
    pxa = px;
    }
  if ((pxa >= umbral)) {
    uo = vent->ty ;
    if ((uo - po + 1) >= lmin) {
      anyadeRaya1 (lineas, po, x, uo, x) ;
      // printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
      }
    }
}

/************************ sigue **********************/

void sigueRayasHor (lista *nlineas, tvent vent, int umbral)
{
  lista lineas;
  int y;
  lineas = listaNueva ();
  for(y=0; y<vent->ty; y++) {
    sigueRayasHor1y (lineas, vent, umbral, y) ;
    }
  *nlineas = lineas;
}

void sigueRayasHorBlan (lista *nlineas, tvent vent, int umbral, int lmin)
{
  lista lineas;
  int y;
  lineas = listaNueva ();
  for(y=0; y<vent->ty; y++) {
    sigueRayasHorBlan1y (lineas, vent, umbral, y, lmin) ;
    }
  *nlineas = lineas;
}

void sigueRayasVer (lista *nlineas, tvent vent, int umbral)
{
  lista lineas;
  int x;
  int xi, xf;
  int inclv;
  lineas = listaNueva ();
  inclv = calculaInclinacionV(vent);
  pon_vprim_vult (inclv, vent->ty, vent->tx, &xi, &xf);
  // printf("inclv:%4d, vent->tx: %4d, xi:%4d, xf: %4d\n",  inclv, vent->tx, xi, xf);    //
  for(x=xi; x<xf; x++) {
    sigueRayasVer1x (lineas, vent, umbral, x, inclv) ;
    }
  *nlineas = lineas;
}

void sigueRayasVerBlanIncl (lista *nlineas, tvent vent, int umbral, int lmin, int inclv)
{
  lista lineas;
  int x;
  int xi, xf;
  lineas = listaNueva ();
  // printf("inclv:%4d, vent->tx: %4d, xi:%4d, xf: %4d\n",  inclv, vent->tx, xi, xf);    //
  for(x=xi; x<xf; x++) {
    sigueRayasVerBlan1x (lineas, vent, umbral, x, lmin, inclv) ;
    }
  *nlineas = lineas;
}

void sigueRayasVerBlanLar (lista *nlineas, tvent vent, int umbral)
{
  int inclv;
  inclv = calculaInclinacionV(vent);
  printf("inclv:%4d\n", inclv);
  sigueRayasVerBlanIncl (nlineas, vent, umbral, vent->ty - 5, inclv); 
}

//*********************** sigueyAgrupa **********************

void sigueyAgrupaRayasHor (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 62);   // porcNeg
  sigueRayasHor (&lineas, vent, umbral);
  agrupaRayas (nlineasAgr, lineas);
  liberaItemsNodosYlista (lineas);
  // imprimeRayas (lineas);
  // imprimeRayas (*nlineasAgr);
}

void sigueyAgrupaRayasHorBlan (lista *nlineasAgr, tvent vent, int lmin)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 48);   // porcNeg
  sigueRayasHorBlan (&lineas, vent, umbral, lmin);
  agrupaRayasB (nlineasAgr, lineas, lmin);
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaRayasHorBlanLar (lista *nlineasAgr, tvent vent)
{
      // ?, o toda? casi toda la ventana
  sigueyAgrupaRayasHorBlan (nlineasAgr, vent, vent->tx - 5);
}

void sigueyAgrupaRayasVer (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent2 (vent, 62);  // porcNeg
  sigueRayasVer (&lineas, vent, umbral);
  // imprimeRayas (lineas);
  agrupaRayas (nlineasAgr, lineas);
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaRayasVerBlanLar (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 55);  // porcNeg
  sigueRayasVerBlanLar (&lineas, vent, umbral);
  agrupaRayas (nlineasAgr, lineas);
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaRayasVerBlanIncl (lista *nlineasAgr, tvent vent, int lmin, int incl)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 55);  // porcNeg
  sigueRayasVerBlanIncl (&lineas, vent, umbral, lmin, incl);
  agrupaRayasB (nlineasAgr, lineas, lmin);
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaRayasVerBlanLarIncl (lista *nlineasAgr, tvent vent, int incl)
{
  sigueyAgrupaRayasVerBlanIncl (nlineasAgr, vent, vent->ty - 5, incl);
}

//*********************** sigue ventana **********************

void sigueRayas (tvent vent)
{
  lista lineasVagr ;
  lista lineasVblanAgr ;
//  lista lineasHagr ;
//  lista lineasHblanAgr ;
  int inclv;
/** /
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  printf ("rayas n. horizonatales\n");
  imprimeRayas (lineasHagr);
/ **/
  sigueyAgrupaRayasVer (&lineasVagr, vent);
  printf ("rayas n. verticales\n");
  imprimeRayas (lineasVagr);
/** /
  sigueyAgrupaRayasHorBlan (&lineasHblanAgr, vent, vent->tx / 8);
  printf ("rayas blancas horizonatales\n");
  imprimeRayas (lineasHblanAgr);
/ **/
  inclv = calculaInclinacionV(vent);
  printf("inclv:%4d\n", inclv);
  sigueyAgrupaRayasVerBlanIncl (&lineasVblanAgr, vent, vent->ty * 4 / 5, inclv);
  printf ("rayas blancas verticales\n");
  imprimeRayas (lineasVblanAgr);
/**/
}

void sigueRayasBlanLar (tvent vent)
{
  lista lineasHblanAgr ;
  lista lineasVblanAgr ;
  //
  sigueyAgrupaRayasHorBlanLar (&lineasHblanAgr, vent);
  imprimeRayas (lineasHblanAgr);
  //
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  imprimeRayas (lineasVblanAgr);
}

int sumaAnchoRayasBlanLarIncl (tvent vent, int incl256)
{
  int sumaAncho;
  lista lineasVblanAgr ;
  int inclven;
  inclven = (vent->ty * incl256 -128 ) / 256;
  sigueyAgrupaRayasVerBlanLarIncl (&lineasVblanAgr, vent, inclven);
  sumaAncho = sumaAnchoRayas (lineasVblanAgr) + abs (inclven);
  liberaItemsNodosYlista (lineasVblanAgr);
  return sumaAncho;
}

//************************ posicion en ventana **********************

void posicionLineaCabecera (tline *nlinea, tvent vent)
{
  lista lineasHagr ;
  tnodol nodol;
  tline line;
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  // imprimeRayas (lineasHagr);
  for (nodol = lineasHagr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ((line->u1 - line->u0) >= ((vent->tx * 65)/100) )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionMargenColumnas (tline *nlinea, tvent vent)
{
  lista lineasVblanAgr ;
  tnodol nodol;
  tline line;
  int centroLinea;
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  // imprimeRayas (lineasVblanAgr);
  for (nodol = lineasVblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    centroLinea = (line->v1 + line->v0) / 2;
    if ( ((line->v1 - line->v0) >= 12 )     &&
         (centroLinea >=  (vent->tx / 3))   &&
         (centroLinea <= ((vent->tx * 2) / 3)) )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionMargenesSeccion (tline *nlinea, tvent vent)
{
  lista lineasHblanAgr ;
  tnodol nodol;
  tline line;
  sigueyAgrupaRayasHorBlanLar (&lineasHblanAgr, vent);
  // imprimeRayas (lineasHblanAgr);
  for (nodol = lineasHblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 30 )     &&
         ( line->v0 > 20              ) )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionesMargenesSeccion (lista *nlineas, tvent vent)
{
  lista lineasMargen ;
  lista lineasHblanAgr ;
  tnodol nodol;
  tline line;
  lineasMargen = listaNueva ();
  sigueyAgrupaRayasHorBlanLar (&lineasHblanAgr, vent);
  // imprimeRayas (lineasHblanAgr);
  for (nodol = lineasHblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 30 )     &&
         ( line->v0 > 20              )     &&
         ((vent->ty - line->v1) > 20  ) )
      anyadeRaya (lineasMargen, copiaRaya (line));
    }
  *nlineas = lineasMargen ;
}

void posicionMargenesMinipage (tline *nlinea, tvent vent)
{
  lista lineasVblanAgr ;
  tnodol nodol;
  tline line;
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  // imprimeRayas (lineasVblanAgr);
  for (nodol = lineasVblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 12 )     &&
         ( line->v0 > 12 )              )
      break ;
    }
  *nlinea = copiaRaya (line);
}

Boolean separadoMargen (int linev0, int  linev1,int  venttm,int  inclv,int  margen)
{
  int lant, lpos;
  lant = 0; lpos = venttm;
  if (inclv >= 0)
    lpos = venttm - inclv ;
  else 
    lant = - inclv ;
  return  ((linev1 - linev0) >= margen ) &&
          ((linev0 - lant)   >= margen ) &&
          ((lpos   - linev1) >= margen )   ;
}

void posicionesMargenesMinipage (lista *nlineas, tvent vent)
{
  lista lineasMargen ;
  lista lineasVblanAgr ;
  tnodol nodol;
  tline line;
  int inclv;
  inclv = calculaInclinacionV(vent);
  lineasMargen = listaNueva ();
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  imprimeRayas (lineasVblanAgr);
  //
  for (nodol = lineasVblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( separadoMargen(line->v0, line->v1, vent->tx, inclv, 12) )
      anyadeRaya (lineasMargen, copiaRaya (line));
    }
  *nlineas = lineasMargen ;
}
